#ifndef EDGE_2DOF_MIRROR_CALIBRATION_H
#define EDGE_2DOF_MIRROR_CALIBRATION_H

#include <g2o/types/slam3d/vertex_se3.h>
#include "g2o_vertex_2DOF.h"
#include <g2o/core/base_multi_edge.h>
#include <cmath>//abs, sin, cos
#include <Eigen/Core>
typedef Eigen::Matrix<double, 6,1> Vector6d;
namespace g2o {

  /**
   * \brief Connection between two camera positions and their extrinsic calibration data
   */
  class Edge2DOFMirrorModel: public BaseMultiEdge<6, Vector6d>
  {
    public:
      EIGEN_MAKE_ALIGNED_OPERATOR_NEW
      Edge2DOFMirrorModel();
      Edge2DOFMirrorModel(VertexSE3* cam1,VertexSE3* cam2, Vertex2DOF* calib);
      typedef Vertex2DOF calibration_vertex_type;

      void computeError();

      virtual bool read(std::istream& is);
      virtual bool write(std::ostream& os) const;

  };

}

#endif
