#include "g2o_edge_simplified_mirror_model.h"
#include "g2o/core/factory.h"
#include "g2o/stuff/macros.h"
namespace g2o {

  EdgeSimpleMirrorCalibration::EdgeSimpleMirrorCalibration() :
    BaseMultiEdge<6, Vector6d>()
  {
    resize(3);
  }

  EdgeSimpleMirrorCalibration::EdgeSimpleMirrorCalibration(VertexSE3* cam1,VertexSE3* cam2, VertexSE2* calib) :
    BaseMultiEdge<6, Vector6d>()
  {
    resize(3);
    _vertices[0] = cam1;
    _vertices[1] = cam2;
    _vertices[2] = calib;
  }

  bool EdgeSimpleMirrorCalibration::read(std::istream& /*is*/)
  {
    return true;
  }

  bool EdgeSimpleMirrorCalibration::write(std::ostream& os) const
  {
    os << " ";
    return os.good();
  }

  G2O_REGISTER_TYPE(EDGE_SIMPLE_MIRROR_CALIBRATION_SE3, EdgeSimpleMirrorCalibration);
} // end namespace
